#include "ui_local.h"
#include "gameinfo.h"

//===================================================================
//
// Crew Menu
//
//===================================================================

// menu action identifiers
#define ID_MAINMENU		100
#define ID_CONTROLS		101
#define ID_VIDEO		102
#define ID_SOUND		103
#define ID_CDKEY		104

#define ID_SENIORDATA	500
#define ID_HAZARDDATA	501
#define ID_HAZARD2DATA	502


#define ID_JANEWAY		900
#define ID_CHAKOTAY		901
#define ID_TUVOK		902
#define ID_TORRES		903
#define ID_PARIS		904
#define ID_KIM			905
#define ID_DOCTOR		906
#define ID_SEVEN		907
#define ID_NEELIX		908

#define ID_FOSTER		909
#define ID_MUNRO		910
#define ID_CHANG		911
#define ID_BIESSMAN		912
#define ID_MURPHY		913
#define ID_CHELL		914
#define ID_JUROT		915
#define ID_CUERVO		916
#define ID_LATHROP		917
#define	ID_ODELL		918
#define	ID_CSATLOS		919
#define	ID_JAWORSKI		920
#define	ID_NELSON		921
#define	ID_LAIRD		922

#define	ID_SENIOR_STAFF	924
#define	ID_HAZARD_ALPHA	925
#define	ID_HAZARD_BETA	926

static menuframework_s		s_crew_menu;
static menubitmap_s			s_senior_data;
static menubitmap_s			s_hazard_data;
static menubitmap_s			s_hazard2_data;
static menubitmap_s			s_mainmenu;
static menubitmap_s			s_seniorstaff1_data;
static menubitmap_s			s_seniorstaff2_data;
static menubitmap_s			s_seniorstaff3_data;
static menubitmap_s			s_seniorstaff4_data;
static menubitmap_s			s_seniorstaff5_data;
static menubitmap_s			s_seniorstaff6_data;
static menubitmap_s			s_seniorstaff7_data;
static menubitmap_s			s_seniorstaff8_data;
static menubitmap_s			s_seniorstaff9_data;

static menubitmap_s			s_hazardteam1_data;
static menubitmap_s			s_hazardteam2_data;
static menubitmap_s			s_hazardteam3_data;
static menubitmap_s			s_hazardteam4_data;
static menubitmap_s			s_hazardteam5_data;
static menubitmap_s			s_hazardteam6_data;
static menubitmap_s			s_hazardteam7_data;

static menubitmap_s			s_hazard2team1_data;
static menubitmap_s			s_hazard2team2_data;
static menubitmap_s			s_hazard2team3_data;
static menubitmap_s			s_hazard2team4_data;
static menubitmap_s			s_hazard2team5_data;
static menubitmap_s			s_hazard2team6_data;
static menubitmap_s			s_hazard2team7_data;

char *munro_pic = 
{
"menu/bios/munro.tga"
};

char *munro_female_pic = 
{
"menu/bios/munro_female.tga"
};

qhandle_t		munro_graphic;	
qhandle_t		munro_female_graphic;	

enum
{
	CREWNAME_JANEWAY,
	CREWNAME_CHAKOTAY,
	CREWNAME_TUVOK,
	CREWNAME_TORRES,
	CREWNAME_PARIS,
	CREWNAME_KIM,
	CREWNAME_DOCTOR,
	CREWNAME_SEVEN,
	CREWNAME_NEELIX,
	CREWNAME_FOSTER,
	CREWNAME_MUNRO,
	CREWNAME_CHANG,
	CREWNAME_BIESSMAN,
	CREWNAME_MURPHY,
	CREWNAME_CHELL,
	CREWNAME_JUROT,
	CREWNAME_CUERVO,
	CREWNAME_LATHROP,
	CREWNAME_ODELL,
	CREWNAME_CSATLOS,
	CREWNAME_JAWORSKI,
	CREWNAME_NELSON,
	CREWNAME_LAIRD,
	CREWNAME_MAX,
};



static char *crewNameFiles [CREWNAME_MAX] = 
{
	"sound/voice/computer/misc/janeway.mp3",
	"sound/voice/computer/misc/chakotay.mp3",
	"sound/voice/computer/misc/tuvok.mp3",
	"sound/voice/computer/misc/torres.mp3",
	"sound/voice/computer/misc/paris.mp3",
	"sound/voice/computer/misc/kim.mp3",
	"sound/voice/computer/misc/emhdoctor.mp3",
	"sound/voice/computer/misc/seven.mp3",
	"sound/voice/computer/misc/neelix.mp3",
	"sound/voice/computer/misc/foster.mp3",
	"sound/voice/computer/misc/munro.mp3",
	"sound/voice/computer/misc/chang.mp3",
	"sound/voice/computer/misc/biessman.mp3",
	"sound/voice/computer/misc/telsia.mp3",
	"sound/voice/computer/misc/chell.mp3",
	"sound/voice/computer/misc/jurot.mp3",
	"sound/voice/computer/misc/oviedo.mp3",
	"sound/voice/computer/misc/kenn.mp3",
	"sound/voice/computer/misc/odell.mp3",
	"sound/voice/computer/misc/csatlos.mp3",
	"sound/voice/computer/misc/jaworski.mp3",
	"sound/voice/computer/misc/nelson.mp3",
	"sound/voice/computer/misc/laird.mp3",
};

sfxHandle_t crewNameHandle [CREWNAME_MAX];

#define CREW_MAXDESC 12
char crewDesc[CREW_MAXDESC][512];


static int	current_Id;	// ID of member currently being viewed

static menubitmap_s *g_senior_staff[] =
{
	&s_seniorstaff1_data, 
	&s_seniorstaff2_data, 
	&s_seniorstaff3_data, 
	&s_seniorstaff4_data, 
	&s_seniorstaff5_data, 
	&s_seniorstaff6_data, 
	&s_seniorstaff7_data, 
	&s_seniorstaff8_data, 
	&s_seniorstaff9_data, 
	NULL,
};

static void *g_hazard_team[] =
{
	&s_hazardteam1_data, 
	&s_hazardteam2_data, 
	&s_hazardteam3_data, 
	&s_hazardteam4_data, 
	&s_hazardteam5_data, 
	&s_hazardteam6_data, 
	&s_hazardteam7_data, 
	NULL,
};


static void *g_hazard_team2[] =
{
	&s_hazard2team1_data, 
	&s_hazard2team2_data, 
	&s_hazard2team3_data, 
	&s_hazard2team4_data, 
	&s_hazard2team5_data, 
	&s_hazard2team6_data, 
	&s_hazard2team7_data, 
	NULL,
};



typedef enum 
{
	CMG_CURRENT_BOX,
	CMG_BOTTOM_BOX1,
	CMG_BOTTOM_BOX2,
	CMG_BOTTOM_BOX3,
	CMG_BOTTOM_BOX4,
	CMG_BOTTOM_BOX5,
	CMG_BOTTOM_BOX6,
	CMG_BOTTOM_BOX7,

	CMG_CURRENT_DESC,

	CMG_SENIORSTAFF_PIC,
	CMG_SENIORSTAFF_DESC1,		

	CMG_ALPHATEAM_PIC,
	CMG_ALPHATEAM_DESC1,		

	CMG_BETATEAM_PIC,
	CMG_BETATEAM_DESC1,		

	CMG_JANEWAY_PIC,
	CMG_JANEWAY_DESC1,		
	CMG_JANEWAY_DESC2,		
	CMG_JANEWAY_DESC3,		
	CMG_JANEWAY_DESC4,		
	CMG_JANEWAY_DESC5,		
	CMG_JANEWAY_DESC6,		
	CMG_JANEWAY_DESC7,		

	CMG_CHAKOTAY_PIC,
	CMG_CHAKOTAY_DESC1,
	CMG_CHAKOTAY_DESC2,
	CMG_CHAKOTAY_DESC3,
	CMG_CHAKOTAY_DESC4,
	CMG_CHAKOTAY_DESC5,
	CMG_CHAKOTAY_DESC6,

	CMG_TUVOK_PIC,
	CMG_TUVOK_DESC1,
	CMG_TUVOK_DESC2,
	CMG_TUVOK_DESC3,
	CMG_TUVOK_DESC4,
	CMG_TUVOK_DESC5,
	CMG_TUVOK_DESC6,

	CMG_TORRES_PIC,
	CMG_TORRES_DESC1,
	CMG_TORRES_DESC2,
	CMG_TORRES_DESC3,
	CMG_TORRES_DESC4,
	CMG_TORRES_DESC5,
	CMG_TORRES_DESC6,

	CMG_PARIS_PIC,
	CMG_PARIS_DESC1,
	CMG_PARIS_DESC2,
	CMG_PARIS_DESC3,
	CMG_PARIS_DESC4,
	CMG_PARIS_DESC5,
	CMG_PARIS_DESC6,
	CMG_PARIS_DESC7,

	CMG_KIM_PIC,
	CMG_KIM_DESC1,
	CMG_KIM_DESC2,
	CMG_KIM_DESC3,
	CMG_KIM_DESC4,
	CMG_KIM_DESC5,
	CMG_KIM_DESC6,

	CMG_DOCTOR_PIC,
	CMG_DOCTOR_DESC1,
	CMG_DOCTOR_DESC2,
	CMG_DOCTOR_DESC3,
	CMG_DOCTOR_DESC4,
	CMG_DOCTOR_DESC5,
	CMG_DOCTOR_DESC6,

	CMG_SEVEN_PIC,
	CMG_SEVEN_DESC1,
	CMG_SEVEN_DESC2,
	CMG_SEVEN_DESC3,
	CMG_SEVEN_DESC4,
	CMG_SEVEN_DESC5,
	CMG_SEVEN_DESC6,

	CMG_NEELIX_PIC,
	CMG_NEELIX_DESC1,
	CMG_NEELIX_DESC2,
	CMG_NEELIX_DESC3,
	CMG_NEELIX_DESC4,
	CMG_NEELIX_DESC5,
	CMG_NEELIX_DESC6,

	CMG_FOSTER_PIC,
	CMG_FOSTER_DESC1,
	CMG_FOSTER_DESC2,
	CMG_FOSTER_DESC3,
	CMG_FOSTER_DESC4,
	CMG_FOSTER_DESC5,
	CMG_FOSTER_DESC6,
	CMG_FOSTER_DESC7,

	CMG_MUNRO_PIC,
	CMG_MUNRO_DESC1,
	CMG_MUNRO_DESC2,
	CMG_MUNRO_DESC3,
	CMG_MUNRO_DESC4,
	CMG_MUNRO_DESC5,
	CMG_MUNRO_DESC6,
	CMG_MUNRO_DESC7,

	CMG_CHANG_PIC,
	CMG_CHANG_DESC1,
	CMG_CHANG_DESC2,
	CMG_CHANG_DESC3,
	CMG_CHANG_DESC4,
	CMG_CHANG_DESC5,
	CMG_CHANG_DESC6,
	CMG_CHANG_DESC7,

	CMG_BIESSMAN_PIC,
	CMG_BIESSMAN_DESC1,
	CMG_BIESSMAN_DESC2,
	CMG_BIESSMAN_DESC3,
	CMG_BIESSMAN_DESC4,
	CMG_BIESSMAN_DESC5,
	CMG_BIESSMAN_DESC6,
	CMG_BIESSMAN_DESC7,

	CMG_MURPHY_PIC,
	CMG_MURPHY_DESC1,
	CMG_MURPHY_DESC2,
	CMG_MURPHY_DESC3,
	CMG_MURPHY_DESC4,
	CMG_MURPHY_DESC5,
	CMG_MURPHY_DESC6,
	CMG_MURPHY_DESC7,

	CMG_CHELL_PIC,
	CMG_CHELL_DESC1,
	CMG_CHELL_DESC2,
	CMG_CHELL_DESC3,
	CMG_CHELL_DESC4,
	CMG_CHELL_DESC5,
	CMG_CHELL_DESC6,
	CMG_CHELL_DESC7,

	CMG_JUROT_PIC,
	CMG_JUROT_DESC1,
	CMG_JUROT_DESC2,
	CMG_JUROT_DESC3,
	CMG_JUROT_DESC4,
	CMG_JUROT_DESC5,
	CMG_JUROT_DESC6,
	CMG_JUROT_DESC7,

	CMG_CUERVO_PIC,
	CMG_CUERVO_DESC1,
	CMG_CUERVO_DESC2,
	CMG_CUERVO_DESC3,
	CMG_CUERVO_DESC4,
	CMG_CUERVO_DESC5,
	CMG_CUERVO_DESC6,
	CMG_CUERVO_DESC7,

	CMG_LATHROP_PIC,
	CMG_LATHROP_DESC1,
	CMG_LATHROP_DESC2,
	CMG_LATHROP_DESC3,
	CMG_LATHROP_DESC4,
	CMG_LATHROP_DESC5,
	CMG_LATHROP_DESC6,
	CMG_LATHROP_DESC7,

	CMG_ODELL_PIC,
	CMG_ODELL_DESC1,
	CMG_ODELL_DESC2,
	CMG_ODELL_DESC3,
	CMG_ODELL_DESC4,
	CMG_ODELL_DESC5,
	CMG_ODELL_DESC6,
	CMG_ODELL_DESC7,

	CMG_CSATLOS_PIC,
	CMG_CSATLOS_DESC1,
	CMG_CSATLOS_DESC2,
	CMG_CSATLOS_DESC3,
	CMG_CSATLOS_DESC4,
	CMG_CSATLOS_DESC5,
	CMG_CSATLOS_DESC6,
	CMG_CSATLOS_DESC7,

	CMG_JAWORSKI_PIC,
	CMG_JAWORSKI_DESC1,
	CMG_JAWORSKI_DESC2,
	CMG_JAWORSKI_DESC3,
	CMG_JAWORSKI_DESC4,
	CMG_JAWORSKI_DESC5,
	CMG_JAWORSKI_DESC6,
	CMG_JAWORSKI_DESC7,

	CMG_NELSON_PIC,
	CMG_NELSON_DESC1,
	CMG_NELSON_DESC2,
	CMG_NELSON_DESC3,
	CMG_NELSON_DESC4,
	CMG_NELSON_DESC5,
	CMG_NELSON_DESC6,
	CMG_NELSON_DESC7,

	CMG_LAIRD_PIC,
	CMG_LAIRD_DESC1,
	CMG_LAIRD_DESC2,
	CMG_LAIRD_DESC3,
	CMG_LAIRD_DESC4,
	CMG_LAIRD_DESC5,
	CMG_LAIRD_DESC6,
	CMG_LAIRD_DESC7,

	CMG_BIO_DESC1,
	CMG_BIO_DESC2,
	CMG_BIO_DESC3,
	CMG_BIO_DESC4,
	CMG_BIO_DESC5,
	CMG_BIO_DESC6,
	CMG_BIO_DESC7,
	CMG_BIO_DESC8,
	CMG_BIO_DESC9,
	CMG_BIO_DESC10,
	CMG_BIO_DESC11,
	CMG_BIO_DESC12,

	CMG_MAX
} crewmenu_graphics_t;

menugraphics_s crewmenu_graphics[CMG_MAX] = 
{
//	type		timer	x		y		width	height	file/text								graphic,	min		max		target					inc		style						color			pointer
	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		CMG_JANEWAY_DESC1,		0,		0,							CT_NONE,		NULL,	// CMG_CURRENT_BOX
	MG_GRAPHIC,	0.0,	216,	392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		216,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX1
	MG_GRAPHIC,	0.0,	196,	392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		196,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX2
	MG_GRAPHIC,	0.0,	176,	392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		176,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX3
	MG_GRAPHIC,	0.0,	156,	392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		156,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX4
	MG_GRAPHIC,	0.0,	136,	392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		136,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX5
	MG_GRAPHIC,	0.0,	116,	392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		116,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX6
	MG_GRAPHIC,	0.0,	96,		392,	17,		36,		"menu/common/square.tga",		0,0,		NULL,		96,		 96,	CMG_JANEWAY_DESC1,		0,		0,							CT_LTBLUE1,		NULL,	// CMG_BOTTOM_BOX7

	MG_VAR,		0.0,	0,		0,		0,		0,		NULL,							0,0,		NULL,		0,		0,		CMG_JANEWAY_DESC1,		0,		0,							CT_NONE,		NULL,	// CMG_CURRENT_DESC

	MG_GRAPHIC,	0.0,	252,	205,	256,	256,	"menu/suit/federation.tga",		0,0,		NULL,		0,		0,		CMG_SENIORSTAFF_DESC1,	0,		0,							CT_WHITE,		NULL,	// CMG_SENIORSTAFF_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL, MNT_SENIORSTAFF_DESC1,0,NULL,		0,		0,		NULL,					0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_SENIORSTAFF_DESC1

	MG_GRAPHIC,	0.0,	252,	205,	256,	256,	"menu/common/hazlogo.tga",			0,0,	NULL,		0,		0,		CMG_ALPHATEAM_DESC1,	0,		0,							CT_WHITE,		NULL,	// CMG_ALPHATEAM_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_ALPHATEAM_DESC1,0,	NULL,		0,		0,		NULL,					0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_ALPHATEAM_DESC1

	MG_GRAPHIC,	0.0,	252,	205,	256,	256,	"menu/common/hazlogo.tga",			0,0,	NULL,		0,		0,		CMG_BETATEAM_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_BETATEAM_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_BETATEAM_DESC1,0,	NULL,		0,		0,		NULL,					0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_BETATEAM_DESC1

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/janeway.tga",			0,0,	NULL,		0,		0,		CMG_JANEWAY_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_JANEWAY_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,	MNT_SENIOR1_DESC1,0,	NULL,		0,		0,		CMG_JANEWAY_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_JANEWAY_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,	MNT_SENIOR1_DESC2,0,	NULL,		0,		0,		CMG_JANEWAY_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JANEWAY_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,	MNT_SENIOR1_DESC3,0,	NULL,		0,		0,		CMG_JANEWAY_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JANEWAY_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,	MNT_SENIOR1_DESC4,0,	NULL,		0,		0,		CMG_JANEWAY_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JANEWAY_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,	MNT_SENIOR1_DESC5,0,	NULL,		0,		0,		CMG_JANEWAY_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JANEWAY_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,	MNT_SENIOR1_DESC6,0,	NULL,		0,		0,		CMG_JANEWAY_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JANEWAY_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,	MNT_SENIOR1_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JANEWAY_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/chakotay.tga",			0,0,	NULL,		0,		0,		CMG_CHAKOTAY_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_CHAKOTAY_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,	MNT_SENIOR2_DESC1,0,	NULL,		0,		0,		CMG_CHAKOTAY_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_CHAKOTAY_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,	MNT_SENIOR2_DESC2,0,	NULL,		0,		0,		CMG_CHAKOTAY_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHAKOTAY_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,	MNT_SENIOR2_DESC3,0,	NULL,		0,		0,		CMG_CHAKOTAY_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHAKOTAY_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,	MNT_SENIOR2_DESC4,0,	NULL,		0,		0,		CMG_CHAKOTAY_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHAKOTAY_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,	MNT_SENIOR2_DESC5,0,	NULL,		0,		0,		CMG_CHAKOTAY_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHAKOTAY_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,	MNT_SENIOR2_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHAKOTAY_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/tuvok.tga",				0,0,	NULL,		0,		0,		CMG_TUVOK_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_TUVOK_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR3_DESC1,0,	NULL,		0,		0,		CMG_TUVOK_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_TUVOK_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR3_DESC2,0,	NULL,		0,		0,		CMG_TUVOK_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TUVOK_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR3_DESC3,0,	NULL,		0,		0,		CMG_TUVOK_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TUVOK_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR3_DESC4,0,	NULL,		0,		0,		CMG_TUVOK_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TUVOK_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR3_DESC5,0,	NULL,		0,		0,		CMG_TUVOK_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TUVOK_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR3_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TUVOK_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/torres.tga",				0,0,	NULL,		0,		0,		CMG_TORRES_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_TORRES_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR4_DESC1,0,	NULL,		0,		0,		CMG_TORRES_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_TORRES_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR4_DESC2,0,	NULL,		0,		0,		CMG_TORRES_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TORRES_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR4_DESC3,0,	NULL,		0,		0,		CMG_TORRES_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TORRES_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR4_DESC4,0,	NULL,		0,		0,		CMG_TORRES_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TORRES_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR4_DESC5,0,	NULL,		0,		0,		CMG_TORRES_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TORRES_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR4_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_TORRES_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/paris.tga",				0,0,	NULL,		0,		0,		CMG_PARIS_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_PARIS_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR5_DESC1,0,	NULL,		0,		0,		CMG_PARIS_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_PARIS_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR5_DESC2,0,	NULL,		0,		0,		CMG_PARIS_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_PARIS_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR5_DESC3,0,	NULL,		0,		0,		CMG_PARIS_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_PARIS_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR5_DESC4,0,	NULL,		0,		0,		CMG_PARIS_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_PARIS_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR5_DESC5,0,	NULL,		0,		0,		CMG_PARIS_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_PARIS_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR5_DESC6,0,	NULL,		0,		0,		CMG_PARIS_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_PARIS_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_SENIOR5_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_PARIS_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/kim.tga",				0,0,	NULL,		0,		0,		CMG_KIM_DESC1,			0,		0,							CT_WHITE,		NULL,	// CMG_KIM_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR6_DESC1,0,	NULL,		0,		0,		CMG_KIM_DESC2,			0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_KIM_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR6_DESC2,0,	NULL,		0,		0,		CMG_KIM_DESC3,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_KIM_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR6_DESC3,0,	NULL,		0,		0,		CMG_KIM_DESC4,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_KIM_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR6_DESC4,0,	NULL,		0,		0,		CMG_KIM_DESC5,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_KIM_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR6_DESC5,0,	NULL,		0,		0,		CMG_KIM_DESC6,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_KIM_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR6_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_KIM_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/doctor.tga",				0,0,	NULL,		0,		0,		CMG_DOCTOR_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_DOCTOR_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR7_DESC1,0,	NULL,		0,		0,		CMG_DOCTOR_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_DOCTOR_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR7_DESC2,0,	NULL,		0,		0,		CMG_DOCTOR_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_DOCTOR_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR7_DESC3,0,	NULL,		0,		0,		CMG_DOCTOR_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_DOCTOR_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR7_DESC4,0,	NULL,		0,		0,		CMG_DOCTOR_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_DOCTOR_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR7_DESC5,0,	NULL,		0,		0,		CMG_DOCTOR_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_DOCTOR_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR7_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_DOCTOR_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/seven.tga",				0,0,	NULL,		0,		0,		CMG_SEVEN_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_SEVEN_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR8_DESC1,0,	NULL,		0,		0,		CMG_SEVEN_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_SEVEN_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR8_DESC2,0,	NULL,		0,		0,		CMG_SEVEN_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR8_DESC3,0,	NULL,		0,		0,		CMG_SEVEN_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR8_DESC4,0,	NULL,		0,		0,		CMG_SEVEN_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR8_DESC5,0,	NULL,		0,		0,		CMG_SEVEN_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR8_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/neelix.tga",				0,0,	NULL,		0,		0,		CMG_NEELIX_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_NEELIX_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_SENIOR9_DESC1,0,	NULL,		0,		0,		CMG_NEELIX_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_NEELIX_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_SENIOR9_DESC2,0,	NULL,		0,		0,		CMG_NEELIX_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_SENIOR9_DESC3,0,	NULL,		0,		0,		CMG_NEELIX_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_SENIOR9_DESC4,0,	NULL,		0,		0,		CMG_NEELIX_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_SENIOR9_DESC5,0,	NULL,		0,		0,		CMG_NEELIX_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_SENIOR9_DESC6,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_SEVEN_DESC6

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/foster.tga",				0,0,	NULL,		0,		0,		CMG_FOSTER_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_FOSTER_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD1_DESC1,0,	NULL,		0,		0,		CMG_FOSTER_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_FOSTER_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD1_DESC2,0,	NULL,		0,		0,		CMG_FOSTER_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_FOSTER_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD1_DESC3,0,	NULL,		0,		0,		CMG_FOSTER_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_FOSTER_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD1_DESC4,0,	NULL,		0,		0,		CMG_FOSTER_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_FOSTER_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD1_DESC5,0,	NULL,		0,		0,		CMG_FOSTER_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_FOSTER_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD1_DESC6,0,	NULL,		0,		0,		CMG_FOSTER_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_FOSTER_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD1_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_FOSTER_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/munro.tga",				0,0,	NULL,		0,		0,		CMG_MUNRO_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_MUNRO_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_DESC1,0,	NULL,		0,		0,		CMG_MUNRO_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_MUNRO_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_DESC2,0,	NULL,		0,		0,		CMG_MUNRO_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MUNRO_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_DESC3,0,	NULL,		0,		0,		CMG_MUNRO_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MUNRO_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_DESC4,0,	NULL,		0,		0,		CMG_MUNRO_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MUNRO_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_DESC5,0,	NULL,		0,		0,		CMG_MUNRO_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MUNRO_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_DESC6,0,	NULL,		0,		0,		CMG_MUNRO_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MUNRO_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MUNRO_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/chang.tga",				0,0,	NULL,		0,		0,		CMG_CHANG_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_CHANG_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD3_DESC1,0,	NULL,		0,		0,		CMG_CHANG_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_CHANG_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD3_DESC2,0,	NULL,		0,		0,		CMG_CHANG_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHANG_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD3_DESC3,0,	NULL,		0,		0,		CMG_CHANG_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHANG_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD3_DESC4,0,	NULL,		0,		0,		CMG_CHANG_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHANG_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD3_DESC5,0,	NULL,		0,		0,		CMG_CHANG_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHANG_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD3_DESC6,0,	NULL,		0,		0,		CMG_CHANG_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHANG_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD3_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHANG_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/biessman.tga",			0,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_BIESSMAN_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD4_DESC1,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_BIESSMAN_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD4_DESC2,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_BIESSMAN_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD4_DESC3,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_BIESSMAN_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD4_DESC4,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_BIESSMAN_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD4_DESC5,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_BIESSMAN_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD4_DESC6,0,	NULL,		0,		0,		CMG_BIESSMAN_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_BIESSMAN_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD4_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_BIESSMAN_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/telsia.tga",				0,0,	NULL,		0,		0,		CMG_MURPHY_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_MURPHY_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD5_DESC1,0,	NULL,		0,		0,		CMG_MURPHY_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_MURPHY_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD5_DESC2,0,	NULL,		0,		0,		CMG_MURPHY_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MURPHY_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD5_DESC3,0,	NULL,		0,		0,		CMG_MURPHY_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MURPHY_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD5_DESC4,0,	NULL,		0,		0,		CMG_MURPHY_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MURPHY_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD5_DESC5,0,	NULL,		0,		0,		CMG_MURPHY_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MURPHY_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD5_DESC6,0,	NULL,		0,		0,		CMG_MURPHY_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MURPHY_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD5_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_MURPHY_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/chell.tga",				0,0,	NULL,		0,		0,		CMG_CHELL_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_CHELL_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD6_DESC1,0,	NULL,		0,		0,		CMG_CHELL_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_CHELL_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD6_DESC2,0,	NULL,		0,		0,		CMG_CHELL_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHELL_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD6_DESC3,0,	NULL,		0,		0,		CMG_CHELL_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHELL_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD6_DESC4,0,	NULL,		0,		0,		CMG_CHELL_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHELL_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD6_DESC5,0,	NULL,		0,		0,		CMG_CHELL_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHELL_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD6_DESC6,0,	NULL,		0,		0,		CMG_CHELL_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHELL_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD6_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CHELL_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/jurot.tga",				0,0,	NULL,		0,		0,		CMG_JUROT_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_JUROT_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD7_DESC1,0,	NULL,		0,		0,		CMG_JUROT_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_JUROT_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD7_DESC2,0,	NULL,		0,		0,		CMG_JUROT_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JUROT_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD7_DESC3,0,	NULL,		0,		0,		CMG_JUROT_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JUROT_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD7_DESC4,0,	NULL,		0,		0,		CMG_JUROT_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JUROT_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD7_DESC5,0,	NULL,		0,		0,		CMG_JUROT_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JUROT_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD7_DESC6,0,	NULL,		0,		0,		CMG_JUROT_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JUROT_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD7_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JUROT_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/oviedo.tga",				0,0,	NULL,		0,		0,		CMG_CUERVO_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_CUERVO_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_1_DESC1,0,	NULL,		0,		0,		CMG_CUERVO_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_CUERVO_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_1_DESC2,0,	NULL,		0,		0,		CMG_CUERVO_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CUERVO_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_1_DESC3,0,	NULL,		0,		0,		CMG_CUERVO_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CUERVO_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_1_DESC4,0,	NULL,		0,		0,		CMG_CUERVO_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CUERVO_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_1_DESC5,0,	NULL,		0,		0,		CMG_CUERVO_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CUERVO_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_1_DESC6,0,	NULL,		0,		0,		CMG_CUERVO_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CUERVO_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_1_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CUERVO_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/kenn.tga",				0,0,	NULL,		0,		0,		CMG_LATHROP_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_LATHROP_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_2_DESC1,0,	NULL,		0,		0,		CMG_LATHROP_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_LATHROP_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_2_DESC2,0,	NULL,		0,		0,		CMG_LATHROP_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LATHROP_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_2_DESC3,0,	NULL,		0,		0,		CMG_LATHROP_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LATHROP_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_2_DESC4,0,	NULL,		0,		0,		CMG_LATHROP_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LATHROP_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_2_DESC5,0,	NULL,		0,		0,		CMG_LATHROP_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LATHROP_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_2_DESC6,0,	NULL,		0,		0,		CMG_LATHROP_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LATHROP_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_2_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LATHROP_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/odell.tga",				0,0,	NULL,		0,		0,		CMG_ODELL_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_ODELL_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_3_DESC1,0,	NULL,		0,		0,		CMG_ODELL_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_ODELL_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_3_DESC2,0,	NULL,		0,		0,		CMG_ODELL_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_ODELL_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_3_DESC3,0,	NULL,		0,		0,		CMG_ODELL_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_ODELL_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_3_DESC4,0,	NULL,		0,		0,		CMG_ODELL_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_ODELL_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_3_DESC5,0,	NULL,		0,		0,		CMG_ODELL_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_ODELL_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_3_DESC6,0,	NULL,		0,		0,		CMG_ODELL_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_ODELL_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_3_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_ODELL_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/csatlos.tga",				0,0,	NULL,		0,		0,		CMG_CSATLOS_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_CSATLOS_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_4_DESC1,0,	NULL,		0,		0,		CMG_CSATLOS_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_CSATLOS_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_4_DESC2,0,	NULL,		0,		0,		CMG_CSATLOS_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CSATLOS_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_4_DESC3,0,	NULL,		0,		0,		CMG_CSATLOS_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CSATLOS_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_4_DESC4,0,	NULL,		0,		0,		CMG_CSATLOS_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CSATLOS_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_4_DESC5,0,	NULL,		0,		0,		CMG_CSATLOS_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CSATLOS_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_4_DESC6,0,	NULL,		0,		0,		CMG_CSATLOS_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CSATLOS_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_4_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_CSATLOS_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/jaworski.tga",				0,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_JAWORSKI_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_5_DESC1,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_JAWORSKI_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_5_DESC2,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JAWORSKI_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_5_DESC3,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JAWORSKI_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_5_DESC4,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JAWORSKI_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_5_DESC5,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JAWORSKI_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_5_DESC6,0,	NULL,		0,		0,		CMG_JAWORSKI_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JAWORSKI_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_5_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_JAWORSKI_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/nelson.tga",				0,0,	NULL,		0,		0,		CMG_NELSON_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_NELSON_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_6_DESC1,0,	NULL,		0,		0,		CMG_NELSON_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_NELSON_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_6_DESC2,0,	NULL,		0,		0,		CMG_NELSON_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_NELSON_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_6_DESC3,0,	NULL,		0,		0,		CMG_NELSON_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_NELSON_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_6_DESC4,0,	NULL,		0,		0,		CMG_NELSON_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_NELSON_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_6_DESC5,0,	NULL,		0,		0,		CMG_NELSON_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_NELSON_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_6_DESC6,0,	NULL,		0,		0,		CMG_NELSON_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_NELSON_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_6_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_NELSON_DESC7

	MG_GRAPHIC,	0.0,	252,	186,	128,	128,	"menu/bios/mackey.tga",				0,0,	NULL,		0,		0,		CMG_LAIRD_DESC1,		0,		0,							CT_WHITE,		NULL,	// CMG_LAIRD_PIC
	MG_STRING,	0.0,	611,	186,	0,		0,		NULL,MNT_HAZARD2_7_DESC1,0,	NULL,		0,		0,		CMG_LAIRD_DESC2,		0,		UI_RIGHT|UI_SMALLFONT,		CT_LTORANGE,	NULL,	// CMG_LAIRD_DESC1
	MG_STRING,	0.0,	382,	208,	0,		0,		NULL,MNT_HAZARD2_7_DESC2,0,	NULL,		0,		0,		CMG_LAIRD_DESC3,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LAIRD_DESC2
	MG_STRING,	0.0,	382,	220,	0,		0,		NULL,MNT_HAZARD2_7_DESC3,0,	NULL,		0,		0,		CMG_LAIRD_DESC4,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LAIRD_DESC3
	MG_STRING,	0.0,	382,	232,	0,		0,		NULL,MNT_HAZARD2_7_DESC4,0,	NULL,		0,		0,		CMG_LAIRD_DESC5,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LAIRD_DESC4
	MG_STRING,	0.0,	382,	244,	0,		0,		NULL,MNT_HAZARD2_7_DESC5,0,	NULL,		0,		0,		CMG_LAIRD_DESC6,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LAIRD_DESC5
	MG_STRING,	0.0,	382,	256,	0,		0,		NULL,MNT_HAZARD2_7_DESC6,0,	NULL,		0,		0,		CMG_LAIRD_DESC7,		0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LAIRD_DESC6
	MG_STRING,	0.0,	382,	268,	0,		0,		NULL,MNT_HAZARD2_7_DESC7,0,	NULL,		0,		0,		CMG_BIO_DESC1,			0,		UI_TINYFONT,				CT_LTPURPLE1,	NULL,	// CMG_LAIRD_DESC7

	MG_STRING,	0.0,	252,	287,	0,		0,		crewDesc[0],0,0,	NULL,		0,		0,		CMG_BIO_DESC2,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC1
	MG_STRING,	0.0,	252,	299,	0,		0,		crewDesc[1],0,0,	NULL,		0,		0,		CMG_BIO_DESC3,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC2
	MG_STRING,	0.0,	252,	311,	0,		0,		crewDesc[2],0,0,	NULL,		0,		0,		CMG_BIO_DESC4,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC3
	MG_STRING,	0.0,	252,	323,	0,		0,		crewDesc[3],0,0,	NULL,		0,		0,		CMG_BIO_DESC5,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC4
	MG_STRING,	0.0,	252,	335,	0,		0,		crewDesc[4],0,0,	NULL,		0,		0,		CMG_BIO_DESC6,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC5
	MG_STRING,	0.0,	252,	347,	0,		0,		crewDesc[5],0,0,	NULL,		0,		0,		CMG_BIO_DESC7,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC6
	MG_STRING,	0.0,	252,	359,	0,		0,		crewDesc[6],0,0,	NULL,		0,		0,		CMG_BIO_DESC8,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC7
	MG_STRING,	0.0,	252,	371,	0,		0,		crewDesc[7],0,0,	NULL,		0,		0,		CMG_BIO_DESC9,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC8
	MG_STRING,	0.0,	252,	383,	0,		0,		crewDesc[8],0,0,	NULL,		0,		0,		CMG_BIO_DESC10,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC9
	MG_STRING,	0.0,	252,	395,	0,		0,		crewDesc[9],0,0,	NULL,		0,		0,		CMG_BIO_DESC11,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC10
	MG_STRING,	0.0,	252,	407,	0,		0,		crewDesc[10],0,0,	NULL,		0,		0,		CMG_BIO_DESC12,		0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC11
	MG_STRING,	0.0,	252,	419,	0,		0,		crewDesc[11],0,0,	NULL,		0,		0,		NULL,				0,		UI_TINYFONT,				CT_LTORANGE,	NULL,	// CMG_BIO_DESC12

};

/*
=================
CrewMenu_Blinkies
=================
*/
void CrewMenu_Blinkies (void)
{
	int descI;

/*	if ((crewmenu_graphics[CMG_CURRENT_BOX].type == MG_VAR) && 
		(crewmenu_graphics[CMG_CURRENT_BOX].timer < uis.realtime))
	{
		index = crewmenu_graphics[CMG_CURRENT_BOX].target;

		if (crewmenu_graphics[index].type != MG_GRAPHIC)	// First time?
		{
			crewmenu_graphics[index].type = MG_GRAPHIC;
			crewmenu_graphics[index].x = crewmenu_graphics[index].min;
		}

		if (index > CMG_BOTTOM_BOX7)
		{
			crewmenu_graphics[CMG_CURRENT_DESC].type = MG_VAR;
			crewmenu_graphics[CMG_CURRENT_DESC].timer = uis.realtime + 15;

			crewmenu_graphics[CMG_CURRENT_BOX].type = MG_OFF;
		}
		else
		{
			crewmenu_graphics[index].x += 5;
			if (crewmenu_graphics[index].x >=  crewmenu_graphics[index].max)
			{
//				ui.S_StartLocalSound( uis.menu_datadisp3_snd, CHAN_MENU1 );

				crewmenu_graphics[index].x = crewmenu_graphics[index].max;

				++crewmenu_graphics[CMG_CURRENT_BOX].target;
				crewmenu_graphics[CMG_CURRENT_BOX].timer = uis.realtime + 15;
			}
		}
	}
	*/
	// Turning on description a line at a time
	if ((crewmenu_graphics[CMG_CURRENT_DESC].timer < uis.realtime) && (crewmenu_graphics[CMG_CURRENT_DESC].type == MG_VAR))
	{
		descI = crewmenu_graphics[CMG_CURRENT_DESC].target;
		if (!descI)
		{
			crewmenu_graphics[CMG_CURRENT_DESC].type = MG_OFF;
		}
		else
		{
			crewmenu_graphics[descI].type = MG_STRING;	// Turnon string
			ui.S_StartLocalSound( uis.menu_datadisp2_snd, CHAN_MENU1 );

			crewmenu_graphics[CMG_CURRENT_DESC].target = crewmenu_graphics[descI].target;	// Set up next line
			crewmenu_graphics[CMG_CURRENT_DESC].timer = uis.realtime + 15;
		}
	} 
}

/*
=================
M_Crew_Graphics
=================
*/
void M_Crew_Graphics (void)
{
	UI_MenuFrame(&s_crew_menu);

	ui.R_SetColor( colorTable[CT_LTBROWN1]);
	UI_DrawHandlePic(30,203,  47, 186, uis.whiteShader);	// Long left column square on bottom 3rd

	ui.R_SetColor( colorTable[CT_LTBLUE1]);
	UI_DrawHandlePic(240,164,  372, 18, uis.whiteShader);	// Top of description box
	UI_DrawHandlePic(240,164,  8,   264, uis.whiteShader);	// Side of desc box
	UI_DrawHandlePic( 236, 392,  4, 36, uis.whiteShader);	// Extra 

	UI_DrawProportionalString(  74,  66, "33660",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
	UI_DrawProportionalString(  74,  84, "284",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
	UI_DrawProportionalString(  74,  188, "3069",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
	UI_DrawProportionalString(  74,  206, "1411-6",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);
	UI_DrawProportionalString(  74,  395, "8080",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);

	UI_DrawProportionalString(  608,  168, "67-278",UI_RIGHT|UI_TINYFONT, colorTable[CT_BLACK]);

	CrewMenu_Blinkies();

	UI_PrintMenuGraphics(crewmenu_graphics,CMG_MAX);

}

/*
=================
M_Crew_MenuDraw
=================
*/
void M_Crew_MenuDraw (void)
{
	M_Crew_Graphics();

	Menu_Draw( &s_crew_menu );
}


/*
=================
FindIndividualId
=================
*/
int FindIndividualId(int id)
{
	int index;

	switch (id)
	{
		case ID_JANEWAY:
			index = CMG_JANEWAY_PIC;
			break;
		case ID_CHAKOTAY:
			index = CMG_CHAKOTAY_PIC;
			break;
		case ID_TUVOK:
			index = CMG_TUVOK_PIC;
			break;
		case ID_TORRES:
			index = CMG_TORRES_PIC;
			break;
		case ID_PARIS:
			index = CMG_PARIS_PIC;
			break;
		case ID_KIM:
			index = CMG_KIM_PIC;
			break;
		case ID_DOCTOR:
			index = CMG_DOCTOR_PIC;
			break;
		case ID_SEVEN:
			index = CMG_SEVEN_PIC;
			break;
		case ID_NEELIX:
			index = CMG_NEELIX_PIC;
			break;
		case ID_FOSTER:
			index = CMG_FOSTER_PIC;
			break;
		case ID_MUNRO:
			if (!Q_stricmp( UI_Cvar_VariableString( "sex" ), "female" )) 
			{
				crewmenu_graphics[CMG_MUNRO_PIC].file = munro_female_pic;
				crewmenu_graphics[CMG_MUNRO_PIC].graphic = munro_female_graphic;
			}
			else
			{
				crewmenu_graphics[CMG_MUNRO_PIC].file = munro_pic;
				crewmenu_graphics[CMG_MUNRO_PIC].graphic = munro_graphic;
			}

			index = CMG_MUNRO_PIC;

			break;
		case ID_CHANG:
			index = CMG_CHANG_PIC;
			break;
		case ID_BIESSMAN:
			index = CMG_BIESSMAN_PIC;
			break;
		case ID_MURPHY:
			index = CMG_MURPHY_PIC;
			break;
		case ID_CHELL:
			index = CMG_CHELL_PIC;
			break;
		case ID_JUROT:
			index = CMG_JUROT_PIC;
			break;
		case ID_CUERVO:
			index = CMG_CUERVO_PIC;
			break;
		case ID_LATHROP:
			index = CMG_LATHROP_PIC;
			break;
		case ID_ODELL:
			index = CMG_ODELL_PIC;
			break;
		case ID_CSATLOS:
			index = CMG_CSATLOS_PIC;
			break;
		case ID_JAWORSKI:
			index = CMG_JAWORSKI_PIC;
			break;
		case ID_NELSON:
			index = CMG_NELSON_PIC;
			break;
		case ID_LAIRD:
			index = CMG_LAIRD_PIC;
			break;

		case ID_SENIOR_STAFF:
			index = CMG_SENIORSTAFF_PIC;
			break;

		case ID_HAZARD_ALPHA:
			index = CMG_ALPHATEAM_PIC;
			break;

		case ID_HAZARD_BETA:
			index = CMG_BETATEAM_PIC;
			break;
		default:
			index = CMG_JANEWAY_PIC;
			break;
	}

	return(index);
}

/*
=================
FindDescIndex
=================
*/
int FindDescIndex(int id)
{
	int index;

	switch (id)
	{
		case ID_JANEWAY:
			index = MNT_SENIOR1_DESC8;
			break;
		case ID_CHAKOTAY:
			index = MNT_SENIOR2_DESC7;
			break;
		case ID_TUVOK:
			index = MNT_SENIOR3_DESC7;
			break;
		case ID_TORRES:
			index = MNT_SENIOR4_DESC7;
			break;
		case ID_PARIS:
			index = MNT_SENIOR5_DESC8;
			break;
		case ID_KIM:
			index = MNT_SENIOR6_DESC7;
			break;
		case ID_DOCTOR:
			index = MNT_SENIOR7_DESC7;
			break;
		case ID_SEVEN:
			index = MNT_SENIOR8_DESC7;
			break;
		case ID_NEELIX:
			index = MNT_SENIOR9_DESC7;
			break;
		case ID_FOSTER:
			index = MNT_HAZARD1_DESC8;
			break;
		case ID_MUNRO:
			if (!Q_stricmp( UI_Cvar_VariableString( "sex" ), "female" )) 
			{
				index = MNT_HAZARD2_FEMALE_DESC8;
				crewmenu_graphics[CMG_MUNRO_DESC1].normaltextEnum = MNT_HAZARD2_FEMALE_DESC1;
				crewmenu_graphics[CMG_MUNRO_DESC2].normaltextEnum = MNT_HAZARD2_FEMALE_DESC2;
				crewmenu_graphics[CMG_MUNRO_DESC3].normaltextEnum = MNT_HAZARD2_FEMALE_DESC3;
				crewmenu_graphics[CMG_MUNRO_DESC4].normaltextEnum = MNT_HAZARD2_FEMALE_DESC4;
				crewmenu_graphics[CMG_MUNRO_DESC5].normaltextEnum = MNT_HAZARD2_FEMALE_DESC5;
				crewmenu_graphics[CMG_MUNRO_DESC6].normaltextEnum = MNT_HAZARD2_FEMALE_DESC6;
				crewmenu_graphics[CMG_MUNRO_DESC7].normaltextEnum = MNT_HAZARD2_FEMALE_DESC7;
			}
			else
			{
				index = MNT_HAZARD2_DESC8;
				crewmenu_graphics[CMG_MUNRO_DESC1].normaltextEnum = MNT_HAZARD2_DESC1;
				crewmenu_graphics[CMG_MUNRO_DESC2].normaltextEnum = MNT_HAZARD2_DESC2;
				crewmenu_graphics[CMG_MUNRO_DESC3].normaltextEnum = MNT_HAZARD2_DESC3;
				crewmenu_graphics[CMG_MUNRO_DESC4].normaltextEnum = MNT_HAZARD2_DESC4;
				crewmenu_graphics[CMG_MUNRO_DESC5].normaltextEnum = MNT_HAZARD2_DESC5;
				crewmenu_graphics[CMG_MUNRO_DESC6].normaltextEnum = MNT_HAZARD2_DESC6;
				crewmenu_graphics[CMG_MUNRO_DESC7].normaltextEnum = MNT_HAZARD2_DESC7;
			}
			break;
		case ID_CHANG:
			index = MNT_HAZARD3_DESC8;
			break;
		case ID_BIESSMAN:
			index = MNT_HAZARD4_DESC8;
			break;
		case ID_MURPHY:
			index = MNT_HAZARD5_DESC8;
			break;
		case ID_CHELL:
			index = MNT_HAZARD6_DESC8;
			break;
		case ID_JUROT:
			index = MNT_HAZARD7_DESC8;
			break;
		case ID_CUERVO:
			index = MNT_HAZARD2_1_DESC8;
			break;
		case ID_LATHROP:
			index = MNT_HAZARD2_2_DESC8;
			break;
		case ID_ODELL:
			index = MNT_HAZARD2_3_DESC8;
			break;
		case ID_CSATLOS:
			index = MNT_HAZARD2_4_DESC8;
			break;
		case ID_JAWORSKI:
			index = MNT_HAZARD2_5_DESC8;
			break;
		case ID_NELSON:
			index = MNT_HAZARD2_6_DESC8;
			break;
		case ID_LAIRD:
			index = MNT_HAZARD2_7_DESC8;
			break;

		case ID_SENIOR_STAFF:
			index = CMG_SENIORSTAFF_PIC;
			break;

		case ID_HAZARD_ALPHA:
			index = CMG_ALPHATEAM_PIC;
			break;

		case ID_HAZARD_BETA:
			index = CMG_BETATEAM_PIC;
			break;
		default:
			index = CMG_JANEWAY_PIC;
			break;
	}

	return(index);
}

/*
=================
SplitDesc
=================
*/
static void SplitDesc(int id)
{
	int	lineWidth,currentWidth,charCnt,currentLineI;
	char *s,*holds;
	char holdChar[2];
	int descI;

	descI = FindDescIndex(id);

	// Clean out any old data
	memset(crewDesc,0,sizeof(crewDesc));

	// Break into individual lines
	s = menu_normal_text[descI];
	holds = s;


	lineWidth = 360;	// How long (in pixels) a line can be
	currentWidth = 0;
	holdChar[1] = '\0';
	charCnt= 0;
	currentLineI = 0;

	while( *s ) 
	{
		++charCnt;
		holdChar[0] = *s;
		currentWidth += UI_ProportionalStringWidth(holdChar,UI_TINYFONT);
		currentWidth +=1; // The space between characters

		if ( currentWidth >= lineWidth )
		{//Reached max length of this line
			//step back until we find a space

			while((currentWidth) && (*s != ' '))
			{
				holdChar[0] = *s;
				currentWidth -= UI_ProportionalStringWidth(holdChar,UI_TINYFONT);
				--s;
				--charCnt;
			}

			Q_strncpyz( crewDesc[currentLineI], holds, charCnt);
			crewDesc[currentLineI][charCnt] = NULL;

			++currentLineI;
			currentWidth = 0;
			charCnt = 0;

			holds = s;
			++holds;

			if (currentLineI > CREW_MAXDESC)
			{
				break;
			}
		}	
		++s;
	}

	++charCnt;  // So the NULL will be properly placed at the end of the string of Q_strncpyz
	Q_strncpyz( crewDesc[currentLineI], holds, charCnt);
	crewDesc[currentLineI][charCnt] = NULL;

}

/*
=================
TurnOnDesc
=================
*/
void TurnOnDesc(int id)
{
	int index,descI;

	current_Id = id;

	index = FindIndividualId(id);

	// First is always the graphic
	crewmenu_graphics[index].type = MG_GRAPHIC;
	descI = crewmenu_graphics[index].target;

	// Second is the big title
	crewmenu_graphics[descI].type = MG_STRING;
	crewmenu_graphics[CMG_CURRENT_DESC].target = crewmenu_graphics[descI].target;	// Set up next line

	crewmenu_graphics[CMG_CURRENT_DESC].type = MG_VAR;
	crewmenu_graphics[CMG_CURRENT_DESC].timer = uis.realtime + 15;

	// Turn off bottom graphic
//	for (index=CMG_BOTTOM_BOX1;index<=CMG_BOTTOM_BOX7;++index)
//	{
//		crewmenu_graphics[index].type = MG_OFF;
//	}

//	crewmenu_graphics[CMG_CURRENT_BOX].target = CMG_BOTTOM_BOX1;
//	crewmenu_graphics[CMG_CURRENT_BOX].type = MG_VAR;
//	crewmenu_graphics[CMG_CURRENT_BOX].timer = uis.realtime + 15;

	// Split up big description line

	SplitDesc(id);

}

/*
=================
ChangeDesc
=================
*/
void ChangeDesc(int id)
{
	int index,i;

	if (current_Id == id)
	{
		return;	//	Just hitting the same key again
	}
	else	// Turn off old description 
	{
		index = FindIndividualId(current_Id);

		crewmenu_graphics[index].type = MG_OFF;	// Turn off picture
	
		index=crewmenu_graphics[index].target; 
		for (i=0;i<CMG_MAX;++i)
		{
			crewmenu_graphics[index].type = MG_OFF;	// Turn off text
			index=crewmenu_graphics[index].target; 
			if (!index)
			{
				break;
			}
		}
	}

	// Turn on description for new ID
	TurnOnDesc(id);

	// Turn on bottom graphic
	for (i=CMG_BOTTOM_BOX1;i<=CMG_BOTTOM_BOX7;++i)
	{
		crewmenu_graphics[i].type = MG_GRAPHIC;
	}
}


/*
=================
Crew_IndividualEvent
=================
*/
static void Crew_IndividualEvent( void* ptr, int notification )
{

	if (notification != QM_ACTIVATED)
		return;

	ui.S_StartLocalSound( crewNameHandle[((menucommon_s*)ptr)->id - ID_JANEWAY],CHAN_MENU2);	// Weapon name

	ChangeDesc(((menubitmap_s*)ptr)->generic.id);

}

/*
=================
Crew_MenuEvent
=================
*/
static void Crew_MenuEvent( void* ptr, int notification )
{
	int i;

	if (notification != QM_ACTIVATED)
		return;

	switch (((menucommon_s*)ptr)->id)
	{
		case ID_VIDEO:
			UI_PopMenu();
			UI_VideoDataMenu();
			return;
		case ID_CONTROLS:
			UI_PopMenu();
			UI_SetupWeaponsMenu();
			break;
		case ID_SOUND:
			UI_PopMenu();
			UI_SoundMenu();
			break;
		case ID_CDKEY:
			UI_PopMenu();
			UI_CDKeyMenu();
			break;
		case ID_MAINMENU:
			UI_PopMenu();
			break;
		case ID_SENIORDATA:
			// Turn on Senior Staff Data
			i = 0;
			while (g_senior_staff[i])
			{
				((menubitmap_s *)g_senior_staff[i])->generic.flags = QMF_HIGHLIGHT_IF_FOCUS;      
				++i;
			}

			// Turn off Hazard Staff Data
			i = 0;
			while (g_hazard_team[i])
			{
				((menubitmap_s *)g_hazard_team[i])->generic.flags = QMF_HIDDEN;      
				++i;
			}

			// Turn off Hazard Staff 2 Data
			i = 0;
			while (g_hazard_team2[i])
			{
				((menubitmap_s *)g_hazard_team2[i])->generic.flags = QMF_HIDDEN;      
				++i;
			}

			s_senior_data.generic.flags				= QMF_GRAYED;
			s_senior_data.textcolor					= CT_WHITE;
			s_senior_data.textcolor2				= CT_WHITE;

			s_hazard_data.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
			s_hazard_data.textcolor					= CT_BLACK;
			s_hazard_data.textcolor2				= CT_WHITE;

			s_hazard2_data.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
			s_hazard2_data.textcolor				= CT_BLACK;
			s_hazard2_data.textcolor2				= CT_WHITE;

			ChangeDesc(ID_SENIOR_STAFF);

			return;

		case ID_HAZARDDATA:
			// Turn off Senior Staff Data
			i = 0;
			while (g_senior_staff[i])
			{
				((menubitmap_s *)g_senior_staff[i])->generic.flags = QMF_HIDDEN;      
				++i;
			}

			// Turn on Hazard Staff Data
			i = 0;
			while (g_hazard_team[i])
			{
				((menubitmap_s *)g_hazard_team[i])->generic.flags = QMF_HIGHLIGHT_IF_FOCUS;      
				++i;
			}

			// Turn off Hazard Staff 2 Data
			i = 0;
			while (g_hazard_team2[i])
			{
				((menubitmap_s *)g_hazard_team2[i])->generic.flags = QMF_HIDDEN;      
				++i;
			}

			s_senior_data.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
			s_senior_data.textcolor					= CT_BLACK;
			s_senior_data.textcolor2				= CT_WHITE;

			s_hazard_data.generic.flags				= QMF_GRAYED;
			s_hazard_data.textcolor					= CT_WHITE;
			s_hazard_data.textcolor2				= CT_WHITE;

			s_hazard2_data.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
			s_hazard2_data.textcolor				= CT_BLACK;
			s_hazard2_data.textcolor2				= CT_WHITE;

			ChangeDesc(ID_HAZARD_ALPHA);

			return;

		case ID_HAZARD2DATA:
			// Turn off Senior Staff Data
			i = 0;
			while (g_senior_staff[i])
			{
				((menubitmap_s *)g_senior_staff[i])->generic.flags = QMF_HIDDEN;      
				++i;
			}

			// Turn off Hazard Staff Data
			i = 0;
			while (g_hazard_team[i])
			{
				((menubitmap_s *)g_hazard_team[i])->generic.flags = QMF_HIDDEN;      
				++i;
			}

			// Turn on Hazard Staff 2 Data
			i = 0;
			while (g_hazard_team2[i])
			{
				((menubitmap_s *)g_hazard_team2[i])->generic.flags = QMF_HIGHLIGHT_IF_FOCUS;      
				++i;
			}

			s_senior_data.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
			s_senior_data.textcolor					= CT_BLACK;
			s_senior_data.textcolor2				= CT_WHITE;

			s_hazard_data.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
			s_hazard_data.textcolor					= CT_BLACK;
			s_hazard_data.textcolor2				= CT_WHITE;

			s_hazard2_data.generic.flags			= QMF_GRAYED;
			s_hazard2_data.textcolor				= CT_WHITE;
			s_hazard2_data.textcolor2				= CT_WHITE;

			ChangeDesc(ID_HAZARD_BETA);

			return;

	}
}

/*
=================
M_Crew_MenuKey
=================
*/
static sfxHandle_t M_Crew_MenuKey( int key )
{
	return Menu_DefaultKey( &s_crew_menu, key );
}


/*
===============
UI_CrewMenu_Cache
===============
*/
void UI_CrewMenu_Cache( void ) 
{
	int i;

	// Precache all menu graphics in array
	for (i=0;i<CMG_MAX;++i)
	{
		if (crewmenu_graphics[i].type == MG_GRAPHIC)
		{
			crewmenu_graphics[i].graphic = ui.R_RegisterShaderNoMip(crewmenu_graphics[i].file);
		}
	}

	munro_graphic = ui.R_RegisterShaderNoMip(munro_pic);
	munro_female_graphic = ui.R_RegisterShaderNoMip(munro_female_pic);

	for (i=0;i<CREWNAME_MAX;i++)
	{
		crewNameHandle[i] = ui.S_RegisterSound(crewNameFiles[i]);
	}

}


/*
===============
CrewMenu_Init
===============
*/
void CrewMenu_Init(void) 
{

	int x,y,i;

	UI_CrewMenu_Cache();

	s_crew_menu.nitems					= 0;
	s_crew_menu.wrapAround				= qtrue;
	s_crew_menu.draw					= M_Crew_MenuDraw;
	s_crew_menu.key						= M_Crew_MenuKey;
	s_crew_menu.fullscreen				= qtrue;
	s_crew_menu.wrapAround				= qfalse;
	s_crew_menu.descX					= MENU_DESC_X;
	s_crew_menu.descY					= MENU_DESC_Y;
	s_crew_menu.titleX					= MENU_TITLE_X;
	s_crew_menu.titleY					= MENU_TITLE_Y;
	s_crew_menu.titleI					= MNT_VOYAGERCREW_TITLE;
	s_crew_menu.footNoteEnum			= MNT_CREWDATA;

	x = 110;
	y = 66;

	// Button Data
	s_senior_data.generic.type				= MTYPE_BITMAP;      
	s_senior_data.generic.flags				= QMF_GRAYED;
	s_senior_data.generic.x					= x;
	s_senior_data.generic.y					= y;
	s_senior_data.generic.name				= "menu/common/square.tga";
	s_senior_data.generic.id				= ID_SENIORDATA;
	s_senior_data.generic.callback			= Crew_MenuEvent;
	s_senior_data.width						= MENU_BUTTON_MED_WIDTH;
	s_senior_data.height					= 50;
	s_senior_data.color						= CT_DKPURPLE1;
	s_senior_data.color2					= CT_LTPURPLE1;
	s_senior_data.textX						= 20;
	s_senior_data.textY						= 20;
	s_senior_data.textEnum					= MBT_SENIORDATA;
	s_senior_data.textcolor					= CT_WHITE;
	s_senior_data.textcolor2				= CT_WHITE;

	x += 170;
	s_hazard_data.generic.type				= MTYPE_BITMAP;      
	s_hazard_data.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
	s_hazard_data.generic.x					= x;
	s_hazard_data.generic.y					= y;
	s_hazard_data.generic.name				= "menu/common/square.tga";
	s_hazard_data.generic.id				= ID_HAZARDDATA;
	s_hazard_data.generic.callback			= Crew_MenuEvent;
	s_hazard_data.width						= MENU_BUTTON_MED_WIDTH;
	s_hazard_data.height					= 50;
	s_hazard_data.color						= CT_DKPURPLE1;
	s_hazard_data.color2					= CT_LTPURPLE1;
	s_hazard_data.textX						= 20;
	s_hazard_data.textY						= 5;
	s_hazard_data.textEnum					= MBT_HAZARDDATA;
	s_hazard_data.textEnum2					= MBT_ALPHASQUAD;
	s_hazard_data.textcolor					= CT_BLACK;
	s_hazard_data.textcolor2				= CT_WHITE;


	x += 170;
	s_hazard2_data.generic.type				= MTYPE_BITMAP;      
	s_hazard2_data.generic.flags			= QMF_HIGHLIGHT_IF_FOCUS;
	s_hazard2_data.generic.x				= x;
	s_hazard2_data.generic.y				= y;
	s_hazard2_data.generic.name				= "menu/common/square.tga";
	s_hazard2_data.generic.id				= ID_HAZARD2DATA;
	s_hazard2_data.generic.callback			= Crew_MenuEvent;
	s_hazard2_data.width					= MENU_BUTTON_MED_WIDTH;
	s_hazard2_data.height					= 50;
	s_hazard2_data.color					= CT_DKPURPLE1;
	s_hazard2_data.color2					= CT_LTPURPLE1;
	s_hazard2_data.textX					= 20;
	s_hazard2_data.textY					= 5;
	s_hazard2_data.textEnum					= MBT_HAZARDDATA;
	s_hazard2_data.textEnum2				= MBT_BETASQUAD;
	s_hazard2_data.textcolor				= CT_BLACK;
	s_hazard2_data.textcolor2				= CT_WHITE;

	s_mainmenu.generic.type					= MTYPE_BITMAP;      
	s_mainmenu.generic.flags				= QMF_HIGHLIGHT_IF_FOCUS;
	s_mainmenu.generic.x					= 482;
	s_mainmenu.generic.y					= 136;
	s_mainmenu.generic.name					= GRAPHIC_BUTTONRIGHT;
	s_mainmenu.generic.id					= ID_MAINMENU;
	s_mainmenu.generic.callback				= Crew_MenuEvent;
	s_mainmenu.width						= MENU_BUTTON_MED_WIDTH;
	s_mainmenu.height						= MENU_BUTTON_MED_HEIGHT;
	s_mainmenu.color						= CT_DKPURPLE1;
	s_mainmenu.color2						= CT_LTPURPLE1;
	s_mainmenu.textX						= MENU_BUTTON_TEXT_X;
	s_mainmenu.textY						= MENU_BUTTON_TEXT_Y;
	s_mainmenu.textEnum						= MBT_MAINMENU;
	s_mainmenu.textcolor					= CT_BLACK;
	s_mainmenu.textcolor2					= CT_WHITE;


	s_seniorstaff1_data.textEnum					= MBT_JANEWAY;
	s_seniorstaff1_data.generic.id					= ID_JANEWAY;
	s_seniorstaff2_data.textEnum					= MBT_CHAKOTAY;
	s_seniorstaff2_data.generic.id					= ID_CHAKOTAY;
	s_seniorstaff3_data.textEnum					= MBT_TUVOK;
	s_seniorstaff3_data.generic.id					= ID_TUVOK;
	s_seniorstaff4_data.textEnum					= MBT_TORRES;
	s_seniorstaff4_data.generic.id					= ID_TORRES;
	s_seniorstaff5_data.textEnum					= MBT_PARIS;
	s_seniorstaff5_data.generic.id					= ID_PARIS;
	s_seniorstaff6_data.textEnum					= MBT_KIM;
	s_seniorstaff6_data.generic.id					= ID_KIM;
	s_seniorstaff7_data.textEnum					= MBT_DOCTOR;
	s_seniorstaff7_data.generic.id					= ID_DOCTOR;
	s_seniorstaff8_data.textEnum					= MBT_SEVEN;
	s_seniorstaff8_data.generic.id					= ID_SEVEN;
	s_seniorstaff9_data.textEnum					= MBT_NEELIX;
	s_seniorstaff9_data.generic.id					= ID_NEELIX;

	s_hazardteam1_data.textEnum						= MBT_FOSTER;
	s_hazardteam1_data.generic.id					= ID_FOSTER;
	s_hazardteam2_data.textEnum						= MBT_MUNRO;
	s_hazardteam2_data.generic.id					= ID_MUNRO;
	s_hazardteam3_data.textEnum						= MBT_CHANG;
	s_hazardteam3_data.generic.id					= ID_CHANG;
	s_hazardteam4_data.textEnum						= MBT_BIESSMAN;
	s_hazardteam4_data.generic.id					= ID_BIESSMAN;
	s_hazardteam5_data.textEnum						= MBT_MURPHY;
	s_hazardteam5_data.generic.id					= ID_MURPHY;
	s_hazardteam6_data.textEnum						= MBT_CHELL;
	s_hazardteam6_data.generic.id					= ID_CHELL;
	s_hazardteam7_data.textEnum						= MBT_JUROT;
	s_hazardteam7_data.generic.id					= ID_JUROT;


	x = 96;
	y = 164;
	i=0;
	while(g_senior_staff[i])
	{
		((menubitmap_s *)g_senior_staff[i])->generic.type		= MTYPE_BITMAP;      
		((menubitmap_s *)g_senior_staff[i])->generic.flags		= QMF_HIGHLIGHT_IF_FOCUS;
		((menubitmap_s *)g_senior_staff[i])->generic.x			= x;
		((menubitmap_s *)g_senior_staff[i])->generic.y			= y;
		((menubitmap_s *)g_senior_staff[i])->generic.name		= "menu/common/square.tga";
		((menubitmap_s *)g_senior_staff[i])->generic.callback	= Crew_IndividualEvent;
		((menubitmap_s *)g_senior_staff[i])->width				= MENU_BUTTON_MED_WIDTH + 10;
		((menubitmap_s *)g_senior_staff[i])->height				= MENU_BUTTON_MED_HEIGHT;
		((menubitmap_s *)g_senior_staff[i])->color				= CT_DKPURPLE1;
		((menubitmap_s *)g_senior_staff[i])->color2				= CT_LTPURPLE1;
		((menubitmap_s *)g_senior_staff[i])->textX				= 4;
		((menubitmap_s *)g_senior_staff[i])->textY				= 1;
		((menubitmap_s *)g_senior_staff[i])->textcolor			= CT_BLACK;
		((menubitmap_s *)g_senior_staff[i])->textcolor2			= CT_WHITE;
		y += 22;
		++i;
	}

	s_hazard2team1_data.textEnum					= MBT_CUERVO;
	s_hazard2team1_data.generic.id					= ID_CUERVO;
	s_hazard2team2_data.textEnum					= MBT_LATHROP;
	s_hazard2team2_data.generic.id					= ID_LATHROP;
	s_hazard2team3_data.textEnum					= MBT_ODELL;
	s_hazard2team3_data.generic.id					= ID_ODELL;
	s_hazard2team4_data.textEnum					= MBT_CSATLOS;
	s_hazard2team4_data.generic.id					= ID_CSATLOS;
	s_hazard2team5_data.textEnum					= MBT_JAWORSKI;
	s_hazard2team5_data.generic.id					= ID_JAWORSKI;
	s_hazard2team6_data.textEnum					= MBT_NELSON;
	s_hazard2team6_data.generic.id					= ID_NELSON;
	s_hazard2team7_data.textEnum					= MBT_LAIRD;
	s_hazard2team7_data.generic.id					= ID_LAIRD;

	x = 96;
	y = 164;
	i = 0;
	while (g_hazard_team[i])
	{

		((menubitmap_s *)g_hazard_team[i])->generic.type			= MTYPE_BITMAP;      
		((menubitmap_s *)g_hazard_team[i])->generic.flags			= QMF_HIDDEN;
		((menubitmap_s *)g_hazard_team[i])->generic.x				= x;
		((menubitmap_s *)g_hazard_team[i])->generic.y				= y;
		((menubitmap_s *)g_hazard_team[i])->generic.name			= "menu/common/square.tga";
		((menubitmap_s *)g_hazard_team[i])->generic.callback		= Crew_IndividualEvent;
		((menubitmap_s *)g_hazard_team[i])->width					= MENU_BUTTON_MED_WIDTH + 10;
		((menubitmap_s *)g_hazard_team[i])->height					= MENU_BUTTON_MED_HEIGHT;
		((menubitmap_s *)g_hazard_team[i])->color					= CT_DKPURPLE1;
		((menubitmap_s *)g_hazard_team[i])->color2					= CT_LTPURPLE1;
		((menubitmap_s *)g_hazard_team[i])->textX					= 4;
		((menubitmap_s *)g_hazard_team[i])->textY					= 1;
		((menubitmap_s *)g_hazard_team[i])->textcolor				= CT_BLACK;
		((menubitmap_s *)g_hazard_team[i])->textcolor2				= CT_WHITE;
		y += 22;
		++i;
	}


	x = 96;
	y = 164;
	i = 0;
	while (g_hazard_team2[i])
	{

		((menubitmap_s *)g_hazard_team2[i])->generic.type			= MTYPE_BITMAP;      
		((menubitmap_s *)g_hazard_team2[i])->generic.flags			= QMF_HIDDEN;
		((menubitmap_s *)g_hazard_team2[i])->generic.x				= x;
		((menubitmap_s *)g_hazard_team2[i])->generic.y				= y;
		((menubitmap_s *)g_hazard_team2[i])->generic.name			= "menu/common/square.tga";
		((menubitmap_s *)g_hazard_team2[i])->generic.callback		= Crew_IndividualEvent;
		((menubitmap_s *)g_hazard_team2[i])->width					= MENU_BUTTON_MED_WIDTH + 10;
		((menubitmap_s *)g_hazard_team2[i])->height					= MENU_BUTTON_MED_HEIGHT;
		((menubitmap_s *)g_hazard_team2[i])->color					= CT_DKPURPLE1;
		((menubitmap_s *)g_hazard_team2[i])->color2					= CT_LTPURPLE1;
		((menubitmap_s *)g_hazard_team2[i])->textX					= 4;
		((menubitmap_s *)g_hazard_team2[i])->textY					= 1;
		((menubitmap_s *)g_hazard_team2[i])->textcolor				= CT_BLACK;
		((menubitmap_s *)g_hazard_team2[i])->textcolor2				= CT_WHITE;
		y += 22;
		++i;
	}

	Menu_AddItem( &s_crew_menu, ( void * )&s_senior_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff1_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff2_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff3_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff4_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff5_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff6_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff7_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff8_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_seniorstaff9_data);

	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam1_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam2_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam3_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam4_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam5_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam6_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazardteam7_data);

	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team1_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team2_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team3_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team4_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team5_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team6_data);
	Menu_AddItem( &s_crew_menu, ( void * )&s_hazard2team7_data);

	Menu_AddItem( &s_crew_menu, ( void * )&s_mainmenu);


	// Turn off all the graphics
	for (i=0;i<CMG_MAX;++i)
	{
		if ((crewmenu_graphics[i].type == MG_GRAPHIC) || (crewmenu_graphics[i].type == MG_STRING))
		{
			crewmenu_graphics[i].type = MG_OFF;
		}
	}

	// Turn on bottom graphic
	for (i=CMG_BOTTOM_BOX1;i<=CMG_BOTTOM_BOX7;++i)
	{
		crewmenu_graphics[i].type = MG_GRAPHIC;
	}

	// Turnon Desc
	TurnOnDesc(ID_SENIOR_STAFF);

}

/*
===============
UI_CrewMenu
===============
*/
void UI_CrewMenu( void) 
{
	
//	if (!s_crew_menu.initialized)
//	{
		CrewMenu_Init(); 
//	}

	UI_PushMenu( &s_crew_menu);
}

